; -------------------------------------------------------------------
; --- Authentication Dialog V1.2c
; --- Copyright  2004 by Dingot0m
;
; --- Contact/Comments/Bug-reporting: dingot0m@gmail.com
; -------------------------------------------------------------------


;--- Dialogs
dialog auth {
  title "Auth Dialog V1.2c"
  size -1 -1 268 212
  option pixels
  tab "Q (QuakeNet)", 1, 4 4 259 185
  text "Username", 4, 22 52 49 16, tab 1
  edit "", 5, 90 49 160 21, tab 1 autohs
  text "Password", 6, 22 73 47 16, tab 1
  edit "", 7, 90 70 160 21, tab 1 pass autohs
  box "Authentication", 8, 13 34 243 64, tab 1
  check "Hide hostmask (Mode +x)", 9, 19 115 145 20, tab 1
  check "Auto-auth when connecting", 10, 19 133 157 20, tab 1
  box "Options", 11, 13 100 243 55, tab 1
  tab "X (UnderNet)", 2
  box "Authentication", 12, 13 34 243 64, tab 2
  text "Username", 13, 22 52 49 16, tab 2
  edit "", 14, 90 49 160 21, tab 2 autohs
  text "Password", 15, 22 73 47 16, tab 2
  edit "", 16, 90 70 160 21, tab 2 pass autohs
  box "Options", 17, 13 100 243 55, tab 2
  check "Hide hostmask (Mode +x)", 18, 19 115 145 20, tab 2
  check "Auto-auth when connecting", 19, 19 133 157 20, tab 2
  tab "NickServ", 3
  box "Authentication", 20, 13 34 243 86, tab 3
  text "Nickname", 23, 22 52 49 16, tab 3
  edit "", 24, 90 49 120 21, tab 3 autohs disable
  text "Password", 25, 22 73 47 16, tab 3
  edit "", 26, 90 70 120 21, tab 3 pass autohs disable
  text "Network", 27, 22 94 41 16, tab 3
  combo 28, 91 92 119 70, tab 3 size drop
  button "Add", 29, 214 50 35 20, tab 3
  button "Edit", 30, 214 72 35 20, tab 3
  button "Del", 31, 214 94 35 20, tab 3
  box "Options", 32, 13 122 243 55, tab 3
  check "Auto-auth on NickServ request", 33, 19 137 171 20, tab 3
  check "Auto-auth when connecting", 34, 19 155 157 20, tab 3
  button "Cancel", 21, 142 190 59 17, cancel
  button "OK", 22, 204 190 59 17, default ok
}

dialog auth.add {
  title "Add username/network"
  size -1 -1 232 92
  option pixels
  text "Nickname", 1, 6 6 49 16
  edit "", 2, 64 4 162 21, autohs
  text "Password", 3, 6 28 47 16
  edit "", 4, 64 25 162 21, pass autohs
  text "Network", 5, 6 49 41 16
  edit "", 6, 64 46 162 21, autohs
  button "Cancel", 7, 104 70 59 17, cancel
  button "OK", 8, 166 70 59 17, ok
}



;--- Aliases
alias auth { if (!$dialog(auth)) { dialog -m auth auth } }
alias auth.nwu {
  did -r auth 28
  var %x = 1
  while (%x <= $ini(auth.ini,NickServ,0)) {
    did -a auth 28 $ini(auth.ini,NickServ,%x)
    inc %x
  }
}
alias auth.login { 
  if ($network == QuakeNet) && (*.quakenet.org iswm $server) { .msg Q@CServe.quakenet.org auth $readini(auth.ini,QuakeNet,Username) $readini(auth.ini,QuakeNet,Password) }
  if ($network == UnderNet) && (*.undernet.org iswm $server) { .msg X@Channels.undernet.org login $readini(auth.ini,UnderNet,Username) $readini(auth.ini,UnderNet,Password) }
  else { halt }
}
alias auth.hidehost { 
  if ($network == QuakeNet) && (*.quakenet.org iswm $server) { mode $me +x }
  if ($network == UnderNet) && (*.undernet.org iswm $server) { mode $me +x }
}

alias auth.nserv {
  if (!$istok(QuakeNet UnderNet,$network,32)) && ($me == $gettok($readini(auth.ini,NickServ,$network),1,32)) { 
    .msg NickServ identify $gettok($readini(auth.ini,NickServ,$network),2,32) 
  }
  else { halt }
}



;--- Popups
menu status,channel,menubar {
  -
  Auth Dialog
  .Auth/Login to Q/X: { auth.login }
  .Hide host: { auth.hidehost }
  .Identify with NickServ: { auth.nserv }
  .-
  .Auth Dialog: { auth }
  .-
  .View auth.ini: { run $mircdirauth.ini }
  -
}



;--- Dialog coding
on *:DIALOG:auth:INIT:*: {

  if ($readini(auth.ini,Options,qnet-hh)) { did -c $dname 9 }
  if ($readini(auth.ini,Options,qnet-aa)) { did -c $dname 10 }

  if ($readini(auth.ini,Options,unet-hh)) { did -c $dname 18 }
  if ($readini(auth.ini,Options,unet-aa)) { did -c $dname 19 }

  if ($readini(auth.ini,Options,nserv-nsaa)) { did -c $dname 33 }
  if ($readini(auth.ini,Options,nserv-aa)) { did -c $dname 34 }

  auth.nwu

  did -a $dname 5 $readini(auth.ini,QuakeNet,Username)
  did -a $dname 7 $readini(auth.ini,QuakeNet,Password)

  did -a $dname 14 $readini(auth.ini,UnderNet,Username)
  did -a $dname 16 $readini(auth.ini,UnderNet,Password)

  did -c $dname 28 1
  did -a $dname 24 $gettok($readini(auth.ini,NickServ,$did($dname,28).seltext),1,32)
  did -a $dname 26 $gettok($readini(auth.ini,NickServ,$did($dname,28).seltext),2,32)
}

on *:DIALOG:auth:SCLICK:22: {
  writeini auth.ini Options qnet-hh $iif($did($dname,9).state == 1,$true,$false)
  writeini auth.ini Options qnet-aa $iif($did($dname,10).state == 1,$true,$false)
  writeini auth.ini Options unet-hh $iif($did($dname,18).state == 1,$true,$false)
  writeini auth.ini Options unet-aa $iif($did($dname,19).state == 1,$true,$false)
  writeini auth.ini Options nserv-nsaa $iif($did($dname,33).state == 1,$true,$false)
  writeini auth.ini Options nserv-aa $iif($did($dname,34).state == 1,$true,$false)
  $iif($did($dname,5).text,writeini auth.ini Quakenet Username $did($dname,5).text,remini auth.ini Quakenet Username)
  $iif($did($dname,7).text,writeini auth.ini Quakenet Password $did($dname,7).text,remini auth.ini Quakenet Password)
  $iif($did($dname,14).text,writeini auth.ini Undernet Username $did($dname,14).text,remini auth.ini Undernet Username)
  $iif($did($dname,16).text,writeini auth.ini Undernet Password $did($dname,16).text,remini auth.ini Undernet Password)
}

on *:DIALOG:auth:SCLICK:28: {
  did -ra $dname 24 $gettok($readini(auth.ini,NickServ,$did($dname,28).seltext),1,32)
  did -ra $dname 26 $gettok($readini(auth.ini,NickServ,$did($dname,28).seltext),2,32)
}

on *:DIALOG:auth:SCLICK:29 {
  dialog -m auth.add auth.add
}

on *:DIALOG:auth:SCLICK:30: {
  set %auth.edit $did($dname,28).seltext
  dialog -m auth.add auth.add
  dialog -t auth.add Edit username/network
  did -a auth.add 2 $did(auth,24).text
  did -a auth.add 4 $did(auth,26).text
  did -a auth.add 6 $did(auth,28).seltext
}

on *:DIALOG:auth:SCLICK:31: {
  remini auth.ini NickServ $did($dname,28).seltext
  auth.nwu
  did -c $dname 28 1
  did -ra $dname 24 $gettok($readini(auth.ini,NickServ,$did($dname,28).seltext),1,32)
  did -ra $dname 26 $gettok($readini(auth.ini,NickServ,$did($dname,28).seltext),2,32)
}

on *:DIALOG:auth.add:SCLICK:8: {
  if ((!$did(2).text) || (!$did(4).text) || (!$did(6).text)) {
    var %x $input(Please fill in all the text-fields,516,Error)
    dialog -v auth.add
    halt
  }
  if (($chr(32) isin $did($dname,2).text) || ($chr(32) isin $did($dname,4).text) || ($chr(32) isin $did($dname,6).text) || ($chr(160) isin $did($dname,2).text) || ($chr(160) isin $did($dname,4).text) || ($chr(160) isin $did($dname,6).text)) {
    var %x $input(Spaces isn't allowed,516,Error)
    dialog -v auth.add
    halt
  }
  if (%auth.edit) {
    remini auth.ini NickServ %auth.edit
    writeini auth.ini NickServ $did($dname,6).text $did($dname,2).text $did($dname,4).text
    auth.nwu
    did -c auth 28 $ini(auth.ini,NickServ,0)
    did -ra auth 24 $gettok($readini(auth.ini,NickServ,$did(auth,28).seltext),1,32)
    did -ra auth 26 $gettok($readini(auth.ini,NickServ,$did(auth,28).seltext),2,32)
    unset %auth.edit
  }
  elseif (!%auth.edit) {
    writeini auth.ini NickServ $did($dname,6).text $did($dname,2).text $did($dname,4).text
    auth.nwu
    did -c auth 28 $ini(auth.ini,NickServ,0)
    did -ra auth 24 $gettok($readini(auth.ini,NickServ,$did(auth,28).seltext),1,32)
    did -ra auth 26 $gettok($readini(auth.ini,NickServ,$did(auth,28).seltext),2,32)
  }
}


;--- Auth coding
raw 001:*: { set -u20 %auth.nswait $true }

on *:NOTICE:*:*: {
  if (*This nickname is registered and protected* iswm $1-) || (*This nickname is owned by someone else* iswm $1-) {
    if (!%auth.nswait) && ($readini(auth.ini,Options,nserv-aa)) && ($me == $gettok($readini(auth.ini,NickServ,$network),1,32)) { .msg NickServ identify $gettok($readini(auth.ini,NickServ,$network),2,32) }
  }
}
on *:TEXT:*:?: {
  if (*This nickname is registered and protected* iswm $1-) || (*This nickname is owned by someone else* iswm $1-) {
    if (!%auth.nswait) && ($readini(auth.ini,Options,nserv-aa)) && ($me == $gettok($readini(auth.ini,NickServ,$network),1,32)) { .msg NickServ identify $gettok($readini(auth.ini,NickServ,$network),2,32) }
  }
}

on *:CONNECT: {
  if ($network == QuakeNet) {
    if ($readini(auth.ini,Options,qnet-aa)) && (*.quakenet.org iswm $server) { msg Q@CServe.quakenet.org auth $readini(auth.ini,QuakeNet,Username) $readini(auth.ini,QuakeNet,Password) }
    if ($readini(auth.ini,Options,qnet-hh)) { .mode $me +x }
  }
  if ($network == UnderNet) {
    if ($readini(auth.ini,Options,unet-aa)) && (*.undernet.org iswm $server) { .msg X@Channels.undernet.org login $readini(auth.ini,UnderNet,Username) $readini(auth.ini,UnderNet,Password) }
    if ($readini(auth.ini,Options,unet-hh)) { .mode $me +x }
  }
  elseif ($me == $gettok($readini(auth.ini,NickServ,$network),1,32)) && ($readini(auth.ini,Options,nserv-aa)) {
    .msg NickServ identify $gettok($readini(auth.ini,NickServ,$network),2,32)
  }
  else { halt }
}

;--- Load/Unload
on *:LOAD: {
  echo -at /\
  echo -at     Loading Auth-Dialog V1.2c...
  echo -at     Made by Dingot0m (dingot0m@gmail.com)
  echo -at     To start the dialog, say: /auth
  echo -at \_______________________________________/
}
on *:UNLOAD: {
  echo -at /\
  echo -at     Unloading Auth-Dialog V1.2c...
  echo -at \_______________________________________/
}
